<?xml version="1.0"?>
  <database name="FUNCTION REM_SHOWALTERNATIVECURRENCY">
    <function name="REM_SHOWALTERNATIVECURRENCY" type="VARCHAR" volatility="STABLE">
      <parameter name="remittance_id" type="VARCHAR" mode="in">
        <default/>
      </parameter>
      <parameter name="payment_id" type="VARCHAR" mode="in">
        <default/>
      </parameter>
      <parameter name="invoice_id" type="VARCHAR" mode="in">
        <default/>
      </parameter>
      <parameter name="order_id" type="VARCHAR" mode="in">
        <default/>
      </parameter>
      <body><![CDATA[/*************************************************************************
* The contents of this file are subject to the Openbravo  Public  License
* Version  1.1  (the  "License"),  being   the  Mozilla   Public  License
* Version 1.1  with a permitted attribution clause; you may not  use this
* file except in compliance with the License. You  may  obtain  a copy of
* the License at http://www.openbravo.com/legal/license.html
* Software distributed under the License  is  distributed  on  an "AS IS"
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
* License for the specific  language  governing  rights  and  limitations
* under the License.
* The Original Code is Openbravo ERP.
* The Initial Developer of the Original Code is Openbravo SLU
* All portions are Copyright (C) 2015-2019 Openbravo SLU
* All Rights Reserved.
* Contributor(s):  ______________________________________.
************************************************************************/

v_showalternativecurrency CHAR(1):='N';
v_finaccount_id REM_Remittance.FIN_Financial_Account_ID%TYPE;
v_paymethod_id REM_Remittance_Type.FIN_Paymentmethod_ID%TYPE;
v_Payin_IsMulticurrency FIN_FinAcc_PaymentMethod.Payin_IsMulticurrency%TYPE;
v_Payout_IsMulticurrency FIN_FinAcc_PaymentMethod.Payout_IsMulticurrency%TYPE;
v_docissotrx CHAR(1);

BEGIN
  IF (remittance_id IS NOT NULL) THEN
    SELECT REM_Remittance.FIN_Financial_Account_ID, REM_Remittance_Type.FIN_Paymentmethod_ID
    INTO v_finaccount_id, v_paymethod_id
    FROM REM_Remittance, REM_Remittance_Type
    WHERE REM_Remittance_Type.REM_Remittance_Type_ID = REM_Remittance.REM_Remittance_Type_ID
    AND REM_Remittance.rem_remittance_id = remittance_id;

    IF (v_finaccount_id IS NOT NULL AND v_paymethod_id IS NOT NULL) THEN
      SELECT Payin_IsMulticurrency, Payout_IsMulticurrency
      INTO v_Payin_IsMulticurrency, v_Payout_IsMulticurrency
      FROM FIN_FinAcc_PaymentMethod
      WHERE FIN_Financial_Account_ID = v_finaccount_id
      AND FIN_Paymentmethod_ID = v_paymethod_id;
            
      -- Payment
      IF (payment_id IS NOT NULL) THEN
        SELECT p.isreceipt INTO v_docissotrx FROM fin_payment p where p.fin_payment_id = payment_id;
    
      -- Invoice
      ELSIF (invoice_id IS NOT NULL) THEN
       SELECT i.issotrx INTO v_docissotrx FROM c_invoice i where i.c_invoice_id = invoice_id;
    
      -- Order
      ELSIF (order_id IS NOT NULL) THEN
       SELECT o.issotrx INTO v_docissotrx FROM c_order o where o.c_order_id = order_id;
      END IF;
      
      -- Logic for showing alternative currency or not
      IF (v_docissotrx = 'Y') THEN
        IF (v_Payin_IsMulticurrency = 'Y') THEN
          v_showalternativecurrency := 'Y';
        END IF;
      ELSIF (v_docissotrx = 'N') THEN
        IF (v_Payout_IsMulticurrency = 'Y') THEN
          v_showalternativecurrency := 'Y';
        END IF;
      END IF;

    END IF;
    
  END IF;
  
  --IF remittance id or payment id and invoice id and order id are null, return N
  RETURN v_showalternativecurrency;
  
EXCEPTION
WHEN OTHERS THEN
  DBMS_OUTPUT.PUT_LINE('rem_showalternativecurrency exception');
  RAISE;
  RETURN NULL;
END REM_SHOWALTERNATIVECURRENCY
]]></body>
    </function>
  </database>
